﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Media.Imaging;
using System.Windows.Media.Media3D;
using System.Windows.Threading;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace BalanceGame
{
	public partial class Window1 : Window
	{
		int[] goal;
		int n, m, rtyp = 0, w = 10;
		bool[,] ban;
		Point3D pos;
		public Window1()
		{
			InitializeComponent();
			string[] ss = Properties.Settings.Default.Data.Replace("\r", "").Split();
			ban = new bool[m = ss[0].Length, n = ss.Length];
			ca.Position = new Point3D(w * m / 2, 200, w * n / 2);
			ca.LookDirection = new Vector3D(0, -200, -0.01);
			var tt = (Transform3DGroup)gr.Transform;
			RotateTransform3D rt1 = (RotateTransform3D)tt.Children[0];
			RotateTransform3D rt2 = (RotateTransform3D)tt.Children[1];
			rt1.CenterX = rt2.CenterX = w * m / 2;
			rt1.CenterZ = rt2.CenterZ = w * n / 2;
			MakeRect(new Point3D(0, -1, 0), new Point3D(m * w, -1, 0), new Point3D(0, -1, n * w), "brGrnd");
			for (int i = 0; i < m; ++i)
			{
				for (int j = 0; j < n; ++j)
				{
					if (ss[j][i] == '*')
					{
						ban[i, j] = true;
						MakeWall(i, j, w);
					}
					if (ss[j][i] == 'S')
					{
						pos = new Point3D((i + 0.5) * w, w / 2, (j + 0.5) * w);
						MakeFloor(i, j, w, "brStart");
					}
					else if (ss[j][i] == 'G')
					{
						goal = new[] { i, j };
						MakeFloor(i, j, w, "brGoal");
					}
				}
			}
			SetPos();
			vi.MouseMove += new MouseEventHandler(vi_MouseMove);
			DispatcherTimer tmr = new DispatcherTimer();
			tmr.Interval = TimeSpan.FromMilliseconds(100);
			tmr.Tick += new EventHandler(tmr_Tick);
			tmr.Start();
		}
		void tmr_Tick(object sender, EventArgs e)
		{
			if (rtyp <= 0) return;
			double x = pos.X / w - 0.5, z = pos.Z / w - 0.5;
			if (Math.Abs(x - goal[0]) < 0.2 && Math.Abs(z - goal[1]) < 0.2)
			{
				rtyp = -1;
				var st = (Storyboard)Resources["fin"];
				st.Begin(this);
				return;
			}
			int ix = (int)Math.Round(x), iz = (int)Math.Round(z);
			int ix2 = ix + ((x + 0.1) % 1 < 0.2 ? 0 : x % 1 < 0.5 ? 1 : -1);
			int iz2 = iz + ((z + 0.1) % 1 < 0.2 ? 0 : z % 1 < 0.5 ? 1 : -1);
			if (ix < 0 || iz < 0 || ix >= m || iz >= n) return;
			double dmax = double.MaxValue, dmin = double.MinValue;
			double ww = w / 5;
			if (rtyp == 1)
			{
				if (ix <= 0 || ban[ix - 1, iz] || ban[ix - 1, iz2]) dmin = (ix + 0.5) * w;
				pos.X = Math.Max(dmin, pos.X - ww);
			}
			else if (rtyp == 2)
			{
				if (iz <= 0 || ban[ix, iz - 1] || ban[ix2, iz - 1]) dmin = (iz + 0.5) * w;
				pos.Z = Math.Max(dmin, pos.Z - ww);
			}
			else if (rtyp == 3)
			{
				if (iz >= n - 1 || ban[ix, iz + 1] || ban[ix2, iz + 1]) dmax = (iz + 0.5) * w;
				pos.Z = Math.Min(dmax, pos.Z + ww);
			}
			else if (rtyp == 4)
			{
				if (ix >= m - 1 || ban[ix + 1, iz] || ban[ix + 1, iz2]) dmax = (ix + 0.5) * w;
				pos.X = Math.Min(dmax, pos.X + ww);
			}
			SetPos();
		}
		void vi_MouseMove(object sender, MouseEventArgs e)
		{
			if (rtyp < 0) return;
			Point p = e.GetPosition(vi);
			VisualTreeHelper.HitTest(vi, null, HitTest, new PointHitTestParameters(p));
		}
		HitTestResultBehavior HitTest(HitTestResult ht)
		{
			var r = ht as RayMeshGeometry3DHitTestResult;
			if (r == null) return HitTestResultBehavior.Continue;
			int rt = (r.PointHit.X / m < r.PointHit.Z / n ? 1 : 2) + (r.PointHit.X / m + r.PointHit.Z / n < w ? 0 : 2);
			if (rt == rtyp) return HitTestResultBehavior.Stop;
			rtyp = rt;
			string[] sts = { "ro1", "ro2", "ro3", "ro4", };
			var st = (Storyboard)Resources[sts[rtyp - 1]];
			st.Begin(this);
			return HitTestResultBehavior.Stop;
		}
		private void SetPos()
		{
			var tr = (Transform3DGroup)ba.Transform;
			var t = (TranslateTransform3D)tr.Children[1];
			t.OffsetX = pos.X;
			t.OffsetY = pos.Y;
			t.OffsetZ = pos.Z;
		}
		private void MakeFloor(int i, int j, int w, string br)
		{
			MakeRect(new Point3D(i * w, 0, j * w), new Point3D(i * w + w, 0, j * w), new Point3D(i * w, 0, j * w + w), br);
		}
		private void MakeWall(int i, int j, int w)
		{
			Point3D p1 = new Point3D(i * w, 0, j * w);
			Point3D p2 = new Point3D(i * w, 0, j * w + w);
			Point3D p3 = new Point3D(i * w, w, j * w);
			Point3D p4 = new Point3D(i * w, w, j * w + w);
			Point3D p5 = new Point3D(i * w + w, 0, j * w);
			Point3D p6 = new Point3D(i * w + w, 0, j * w + w);
			Point3D p7 = new Point3D(i * w + w, w, j * w);
			Point3D p8 = new Point3D(i * w + w, w, j * w + w);
			MakeRect(p1, p3, p2, "brWall");
			MakeRect(p2, p4, p6, "brWall");
			MakeRect(p6, p8, p5, "brWall");
			MakeRect(p5, p7, p1, "brWall");
			MakeRect(p4, p3, p8, "brWall");
		}
		private void MakeRect(Point3D p1, Point3D p2, Point3D p3, string br)
		{
			GeometryModel3D gm = new GeometryModel3D();
			gr.Children.Add(gm);
			gm.Material = (Material)Resources[br];
			MeshGeometry3D mg = new MeshGeometry3D();
			gm.Geometry = mg;
			mg.Positions.Add(p1);
			mg.Positions.Add(p2);
			mg.Positions.Add(p3);
			mg.Positions.Add(p2 + (p3 - p1));
			foreach (int i in new[] { 0, 2, 1, 1, 2, 3 })
				mg.TriangleIndices.Add(i);
		}
	}
}
